--[[
######################################################################
##  File:	Militia.lua												##
##  Author:	'OliveD' (olived@live.ca)								##
##	Notes:	Random generation on the militias. Now is a single .lua	##
##			for all the different presets. Looks like I managed		##
##			to overcomplicate this script, too.						##
######################################################################
]]--

--Militia decoding array/tables
MilitiaPresetValues={};
MilitiaPresetNames={};
MilitiaNumOfPresets = 1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Rifles I";
MilitiaPresetValues[MilitiaNumOfPresets]={"Militia Rifle","Militia Rifle Bayonet"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Rifles II";
MilitiaPresetValues[MilitiaNumOfPresets]={"Militia Battle Rifle"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Pistols I";
MilitiaPresetValues[MilitiaNumOfPresets]={"Obrez"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Pistols II";
MilitiaPresetValues[MilitiaNumOfPresets]={"Militia Pistol"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Snipers I";
MilitiaPresetValues[MilitiaNumOfPresets]={"Militia Sniper's Rifle"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Flintlocks I";
MilitiaPresetValues[MilitiaNumOfPresets]={"Flintlock","Flintlock Bayonet"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Flintlocks II";
MilitiaPresetValues[MilitiaNumOfPresets]={"Handcannon"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Plasma Guns I";
MilitiaPresetValues[MilitiaNumOfPresets]={"Militia Plasma Pistol"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Plasma Guns II";
MilitiaPresetValues[MilitiaNumOfPresets]={"Militia Plasma Rifle"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

MilitiaPresetNames[MilitiaNumOfPresets]="Militia Machineguns I";
MilitiaPresetValues[MilitiaNumOfPresets]={"Militia Machinegun"};
MilitiaNumOfPresets=MilitiaNumOfPresets+1;

function FindMilitiaPreset(name)
	for i=1,MilitiaNumOfPresets do
		if MilitiaPresetNames[i] == name then
			return MilitiaPresetValues[i][math.floor(math.random(1,table.getn(MilitiaPresetValues[i])))];
		end
	end
	return nil;
end
--end

function ApplyInventory(target,source,weapon)
	if ToAHuman(source).EquippedItem ~= nil then
		if ToAHuman(source).EquippedItem.ClassName == "HDFirearm" then
			target:AddInventoryItem(CreateHDFirearm(ToAHuman(source).EquippedItem.PresetName));
		elseif ToAHuman(source).EquippedItem.ClassName == "HeldDevice" then
			target:AddInventoryItem(CreateHeldDevice(ToAHuman(source).EquippedItem.PresetName));
		elseif ToAHuman(source).EquippedItem.ClassName == "TDExplosive" then
			target:AddInventoryItem(CreateTDExplosive(ToAHuman(source).EquippedItem.PresetName));
		end
	end
	if weapon ~= nil then
		target:AddInventoryItem(CreateHDFirearm(weapon));
	end
	for i=0,ToAHuman(source).InventorySize-1,1 do
		local Iteratorb = ToAHuman(source).Inventory();
		if Iteratorb.ClassName == "HDFirearm" then
			target:AddInventoryItem(CreateHDFirearm(Iteratorb.PresetName));
		elseif Iteratorb.ClassName == "HeldDevice" then
			target:AddInventoryItem(CreateHeldDevice(Iteratorb.PresetName));
		elseif Iteratorb.ClassName == "TDExplosive" then
			target:AddInventoryItem(CreateTDExplosive(Iteratorb.PresetName));
		end
		source:SwapNextInventory(myIteratorb,true);
	end
end

function SpawnMilitia(name,actor)
	local spawnName = "Militia ";
	local myRand=math.floor(math.random(1,13));
	--First figure out if we're spawning a regular or heavy
	if string.find(name, "Heavy") then
		spawnName = "Militia Heavy ";
		myRand=math.floor(math.random(1,4));
	end
		
	
	local mySpawned;
	local spawnTarget;
	spawnName = spawnName..myRand;
	mySpawned = CreateAHuman(spawnName);
	--Identify which weapon we have to spawn
	if name ~= "Militia" and name ~= "Militia Heavy" then --No weapon for default actors
		local weapontarget = FindMilitiaPreset(name);
		if weapontarget ~= nil then
			ApplyInventory(mySpawned,actor,weapontarget)
		else
			ApplyInventory(mySpawned,actor);
		end
	else
		ApplyInventory(mySpawned,actor);
	end
	return mySpawned;
end

function Create(self)
	local mySpawned = SpawnMilitia(self.PresetName,self);
	mySpawned.AIMode = 1;
	mySpawned.Team=self.Team;
	mySpawned.Pos=self.Pos;
	mySpawned.Vel=self.Vel;
	mySpawned.RotAngle=self.RotAngle;
	mySpawned.AngularVel=self.AngularVel;
	MovableMan:AddActor(mySpawned)
	self.ToDelete = true;
end

